library(future)
library(future.apply)
library(future.batchtools)


tardis <- parallelly::makeClusterPSOCK("tardis.mpib-berlin.mpg.de",
                                       port='random', user="peikert",
                                       # this R version does not matter
                                       # it only requires that future.batchtools is there
                                       rscript=c("/opt/software/R/4.0.3/bin/Rscript"), 
                                       homogeneous = TRUE)
# should be 1 if no hierarchical futures are used
ncpus <- 1
plan(list(tweak(cluster, workers=tardis),
          tweak(batchtools_slurm,
                workers = 100, #number of tasks that may run parallel on tardis
                # the R/package version of the singularity image has to match
                # the local machine, therefore check Dockerfile for R version
                template = "/home/mpib/peikert/.batchtools.slurm.singularity.tmpl",
                resources=list(ncpus=ncpus,
                               memory='700m',
                               walltime=6600,
                               partition=c('gpu'))),
          tweak(multicore, workers=ncpus)))


# ok, this is really dumb
pkgs %<-% sessionInfo()
x %<-% future_sapply( 1:10, FUN=function(x){x**x})
x
